function renderContainer(obj) {
  $(obj).find(".nocopy").remove();
  if ($(obj).find(">gc-container-cost").length == 0) $(obj).find(">name,>description").after("<gc-container-cost class='nosave'></gc-container-cost>");
  if ($(obj).find(">gc-container-weight").length == 0) $(obj).find(">name,>description").after("<gc-container-weight class='nosave'></gc-container-weight>");
  $(obj).find(">name,>description,>value").addClass("editable");
  $(obj).lightStatus("container-cost-modified",$(obj).find(">modifier>cost").int());

  // equipment containers
  if ($(obj).find("equipped").length == 0) $(obj).find(">gc-container-weight").after("<equipped class='nosave'></equipped>");
  $(obj).find("equipped").unbind("click").bind("click",function () {
    var oldState=$(this).parent().attr("state");
    var newState="carried";
    if (oldState=="carried") newState="not carried";
    if (oldState=="not carried") newState="equipped";

    $(this).parent().attr("state",newState);
    $(this).parent().find("equipment,equipment_container").attr("state",newState);
    calcAllSchedule();
    saveButtonEnable();

    event.stopPropagation();
  });

  $(obj).unbind("click").bind("click",function (){selectElement(this); return(false)});

  if ($(obj).find(">expander").length == 0) $(obj).prepend("<expander class='nosave'/>");
  $(obj).find("expander").unbind('click').bind('click',function () {containerToggleExpand($(this).parent());});

  $(obj).unbind("dblclick").bind("dblclick", function () { editContainer($(this)); event.stopPropagation(); });


  $(obj).find(">list-menu").remove();
  var list = $("<list-menu class='nosave'></list-menu>");
  $(list).click(function () {
    showFloatPanel($(this).parent(), "container")
  });
  $(obj).find(">name,>description").after(list);

  renderWeaponsAndVars(obj);
}

function editContainer(obj,cancelDelete) {
  if (viewerMode) return;
  var objTag=($(obj)[0].tagName.toLowerCase());

  var objType=($(obj).attr('type'));

  var text="";

  text+="<line>Заголовок <input type='text' id='container_name' style='width: 380px; max-width: 100%;' value='"+$(obj).find(">name,>description").text()+"'></line>";


  if (objTag=="advantage_container"){
    text+="<line>Тип контейнера <select id='contaiter_type'>";
    text+="<option value=''>Группа</option>";
    text+="<option value='meta trait' "+((objType=='meta trait')?'selected':'')+">Мета-черта</option>";
    text+="<option value='race' "+((objType=='race')?'selected':'')+">Раса</option>";
    text+="<option value='alternative abilities' "+((objType=='alternative abilities')?'selected':'')+">Альтернативная способность</option>";
    text+="</select></line>";
  }

  if (objTag!="equipment_container") text+="<line>Модификатор цены <input type='number' id='container_pecent' style='width:60px' min='-100' value='"+($(obj).find(">modifier>cost").int()||0)+"'>%<div class='note'>возможны отрицательные значения. Ноль означает - не модифицировать</div></line>";

  if (objTag=="equipment_container") {
    text+="<line>Вес самого контейнера <input type='text' id='container_weight' style='width:60px' value='"+$(obj).find(">weight").text()+"'> lb <div class='note'>не содержимого, только самого контейнера</div></line>";
    text+="<line>Цена самого контейнера $<input type='text' id='container_value' style='width:60px' value='"+$(obj).find(">value").text()+"'></line>";

  }



    modalPopup("<h4>Группа</h4>"+text,"Ok","Cancel",function (){

    $(obj).find(">name,>description").html($("#container_name").val());

    var val=$("#contaiter_type").val();
    $(obj).attr('type',val);
    if (val=="") $(obj).removeAttr('type');

    var val=$('#container_pecent').val();
    $(obj).find(">modifier").remove();
    if (val>0||val<0) {

      $(obj).find(">gc-container-cost").after("<modifier>\n<name>Модификатор</name>\n<cost type=\"percentage\">"+val+"</cost>\n</modifier>");
    }

    $(obj).find(">weight").remove();
    if ($('#container_weight').val()!==undefined&&$('#container_weight').val()!=="") {
      $(obj).find(">gc-container-cost").after("<weight>"+$('#container_weight').val()+"</weight>");
    }

    $(obj).find(">value").remove();
    if ($('#container_value').val()!==undefined&&$('#container_value').val()!=="") {
      $(obj).find(">gc-container-cost").after("<value>"+$('#container_value').val()+"</value>");
    }

    renderContainer($(obj));

    setModifyAttr($(obj),"changed");

    calcAll();
    saveButtonEnable();
    flashObj($(obj));
  },null,function(){$("#container_name").focus();});
}

function checkEmptyContainers() {
  globalChar.find(".empty-container").remove();
  globalChar.find("advantage_container").each(function () {
    if ($(this).find("advantage").length == 0) $(this).append("<advantage class='nosave empty-container'></advantage>");
  });
  globalChar.find("skill_container").each(function () {
    if ($(this).find("skill,technique").length == 0) $(this).append("<skill class='nosave empty-container'></skill>");
  });
  globalChar.find("spell_container").each(function () {
    if ($(this).find("spell").length == 0) $(this).append("<spell class='nosave empty-container'></spell>");
  });
  globalChar.find("equipment_container").each(function () {
    if ($(this).find("equipment").length == 0) {
      //if (isEquipmentAutoContainer($(this))) convertContainerToEquipment($(this));
      $(this).append("<equipment class='nosave empty-container'></equipment>");
    }
  })
}

function containerToggleExpand (obj){
  if ($(obj)[0].getAttribute('open') == 'no')
    $(obj)[0].setAttribute("open", "yes");
  else
    $(obj)[0].setAttribute("open", "no");
  event.stopPropagation();
}