function floatPanelCustomChar(obj){
  $("float-panel").find(".hide").removeClass('hide');
  $("float-panel").find("custom-buttons").html("");

  if ($(obj)[0].tagName.toLowerCase()!=="obj") return

  var list=$(obj).parents("obj-list");

  if (!list.hasClass("can-modify-items")) $("float-panel").find("edit-xml").addClass('hide');

  if (!list.hasClass("can-move")) $("float-panel").find("label,move-top,move-bottom,move-up,move-down,move-right,move-left").addClass('hide');

  if (!list.hasClass("can-modify")) $("float-panel").find("duplicate,copy,past,delete").addClass('hide');

  if (!list.hasClass("can-colors")) $("float-panel").find("colors").addClass('hide');

  list.trigger("panel",obj);
}
function addFloatPanelButton(obj){
  $("float-panel").find("custom-buttons").append($(obj).addClass('item'));
}

function changeCustomList(obj){
  var proto=$(obj).find("obj-prototype").clone();
  clearObj(proto);
  modalPopup(`<h2>Настройки сипска</h2>
  <line>Тип списка <input type='text' id=m_type value='${$(obj).attr("type")||""}' style="width: 200px;"></line>
  <line><input type='text' id=m_options value='${$(obj).attr("options")||""}' style="width: 100%;"></line>
  <h3>Fuctional</h3>
  <line>can-select can-move can-modify can-modify-items can-colors</line>
  <h3>Visual</h3>
  <line>medium columns-3 columns-2</line>
  <h3>Прототип внутренних объектов</h3>
  <line><textarea id=m_proto style="width:100%; height:150px;">${proto.html()||""}</textarea></line>
`,'Сохранить','Отменить',function () {
    obj.attr("options",$("modalpopup #m_options").val());
    obj.attr("type",$("modalpopup #m_type").val());
    obj.find("obj-prototype").remove();
    obj.prepend("<obj-prototype>"+$("modalpopup #m_proto").val()+"</obj-prototype>")
    saveButtonEnable();
    renderChar();
    calcAllSchedule();
  })
}

function renderCustomCharLess(){
  var lessObj=globalChar.find("gc-style-less");
  less.render(".mentor character {"+base64_to_utf8(globalChar.find("gc-style-less").html())+"}").then(function (output) {
    gm(".custom-less").remove();
    lessObj.after("<style class='nosave custom-less'>" + output.css + "</style>");
  }, function (error) {echo ("! Less error: "+error.message,error)});
}

function toggleEditMode(obj){
  if (viewerMode) {flyAlert("Запрещено в режиме просмотра",obj); return;}
  if (lockedMode) {flyAlert("Лист персонажа заблокирован",obj); return;}
  if (!editMode) flyAlert("Режим редактирования шаблона.<br>Все что вы делаете требует <u>сериозного понимания</u>!!!",$(obj));
  toggleMode('editMode');
}

function changeCustomCss(){
  var aceEditor;

  modalPopup(`
  <style>
    modalpopup help {text-align:left; display: none; overflow: auto; flex-basis: max(300px,50%); border-left:4px solid #9993; padding-left:20px; margin-left:20px; height:100%;}
    modalpopup help.expand { display: block; }
    modalpopup help i {color: var(--color-main); font-style: normal; font-weight: 600;}
  </style>
  <button style="float:right;" onclick="$('modalpopup help').toggleClass('expand');"><i class="fa fa-help"></i> документация</button>
  <h2>CSS</h2>
  <div  style="display:flex;"><div id=m_style style="width:100%; height:70vh;"></div><help>${$("constants help custom-less-help").html()}</help></div>
`,'Сохранить','Отменить',function () {

    globalChar.find(">character>gc-style-less").remove();
    globalChar.find(">character").append("<gc-style-less>"+utf8_to_base64(aceEditor.getValue())+"</gc-style-less>");


    sessionStorage.setItem("cssLastLine",aceEditor.getCursorPosition().row+1);
    aceEditor.destroy();
    saveButtonEnable();
    renderCustomCharLess();
  },null,function () {
    $("modalpopup").addClass("ultra-wide");
    aceEditor=createMentorAce("m_style","css");
    aceEditor.setValue(base64_to_utf8(globalChar.find("gc-style-less").html()||""),-1);
    aceEditor.gotoLine(sessionStorage.getItem("cssLastLine")*1);
    aceEditor.focus();

  })
}
function changeCustomJs(){
  var aceEditor;

  modalPopup(`
  <style>
    modalpopup help {text-align:left; display: none; overflow: auto; flex-basis: max(300px,50%); border-left:4px solid #9993; padding-left:20px; margin-left:20px; height:100%;}
    modalpopup help.expand { display: block; }
    modalpopup help i {color: var(--color-main); font-style: normal; font-weight: 600;}
  </style>
  <button style="float:right;" onclick="$('modalpopup help').toggleClass('expand');"><i class="fa fa-help"></i> документация</button>
  <h2>Java Script</h2>
  <div style="display:flex;"><div id=m_code style="width:100%; height:70vh;"></div><help>${$("constants help custom-js-help").html()}</help></div>
`,'Сохранить','Отменить',function () {

   globalChar.find(">character>gc-script").remove();
   globalChar.find(">character").append("<gc-script>"+utf8_to_base64(aceEditor.getValue())+"</gc-script>");

    sessionStorage.setItem("scriptLastLine",aceEditor.getCursorPosition().row+1);
    aceEditor.destroy();
    saveButtonEnable();
    calcAll();
  },null,function () {
    $("modalpopup").addClass("ultra-wide");
    aceEditor= createMentorAce("m_code","javascript");
    aceEditor.setValue(base64_to_utf8(globalChar.find("gc-script").html()||""),-1);
    aceEditor.gotoLine(sessionStorage.getItem("scriptLastLine")*1);
    aceEditor.focus();
  })
}

function changeCustomXml(){

  if (classicRenderMode) {
    flyAlert('Режим расширения стандартных листов - xml менять невозможно');
    return;
  }


  var aceEditor;



  modalPopup(`<h2>Basic XML model</h2>
  <line><div id=m_xml style="width:100%; height:70vh;"></div></line>
`,'Сохранить и сбросить лист','Отменить',function () {
    globalChar.find("gc-basic-xml").html(utf8_to_base64(aceEditor.getValue()));
    sessionStorage.setItem("xmlLastLine",aceEditor.getCursorPosition().row+1);
    aceEditor.destroy();
    resetFromBasicXml();
  },null,function () {
    $("modalpopup").addClass("ultra-wide");
    aceEditor= createMentorAce("m_xml","xml");
    aceEditor.setValue(base64_to_utf8(globalChar.find("gc-basic-xml").html()||""),-1);
    aceEditor.gotoLine(sessionStorage.getItem("xmlLastLine")*1);
    aceEditor.focus();



    var btn=$("<button style='float: right;'>Взять в шаблон текущий лист</button>").on("click",function () {
      if (confirm ('Это затрет текущий шаблон!!!')) {
        var newObj=globalChar.find(">character").clone();
        newObj.find("created_date,modified_date,gc-style-less,gc-script,gc-basic-xml").remove();
        clearObj(newObj);
        aceEditor.setValue(newObj.html(),-1);
        aceEditor.focus();
      }
    });
    $("modalpopup message").prepend(btn);
  })
}

function resetFromBasicXml(){
  if (globalChar.find("gc-basic-xml").length===0) {flyAlert("Отменено. Нет базового шаблона!!!",globalChar); return;}

  undoSave();
  var dates=globalChar.find("created_date,modified_date").clone();
  var bases=globalChar.find("gc-style-less,gc-script,gc-basic-xml").clone();
  var xml=base64_to_utf8(globalChar.find("gc-basic-xml").html());
  globalChar.find(">character").html("").append(dates).append(xml).append(bases);
  undoSave();
  renderChar();
  saveButtonEnable();
  calcAll();
}

function updateBasicXmlFromChar(){
  // не актуально можно будет удалить!!!
  if (globalChar.find("gc-basic-xml").length===0) {flyAlert("Отменено. Нет базового шаблона!!!",globalChar); return;}

  undoSave();
  var newObj=globalChar.find(">character").clone();
  newObj.find("created_date,modified_date,gc-style-less,gc-script,gc-basic-xml").remove();
  clearObj(newObj);
  globalChar.find("gc-basic-xml").html(utf8_to_base64(newObj.html()));

  undoSave();
  saveButtonEnable();
}

function renderCustomChar(){
  clearObj((globalChar).find("character"));


  gm("[options]").each(function () {$(this).addClass($(this).attr("options"));})

  gm("obj-list").each(function () {
    var toolbar = $("<obj-toolbar class='nosave'></obj-toolbar>");
    if ($(this).hasClass("can-modify")) {
      var el=$("<i class='fa fa-plus'></i>").on("click",function(){addCustomItem($(this).parent().parent())});
      toolbar.append(el);
    }

    var el=$("<i class='fa fa-cog show-in-edit-mode-only'></i>").on("click",function(){changeCustomList($(this).parent().parent())});
    toolbar.append(el);

    $(this).prepend(toolbar);
  });

  renderCustomCharLess();


}

function renderCustomItem(obj){
  $(obj).find("points").addClass("spinner spinner-not-negative editable");

  $(obj).find("[options]").each(function () {$(this).addClass($(this).attr("options"));})

  $(obj).find("[type=dots]").each(function () {
    var el=$("<gc-dots class='nosave'></gc-dots>");
    if ($(this).attr("max")>0) el.attr("max",$(this).attr("max"));
    el.addClass($(this).attr("options"));
    $(this).after(el);
    $(this).hide();
  });

  if ($(obj).parents(".can-select").length) $(obj).unbind("click").bind("click",function (){selectElement(this); return(false);});

  $(obj).find("list-menu").remove();
  var list=$("<list-menu class='nosave'></list-menu>");
  $(list).click(function (){ showFloatPanel($(this).parent()) });
  $(obj).prepend(list);
}

function addCustomItem(obj){
  var el=$("<obj></obj>");
  el.html($(obj).find("obj-prototype").html());
  el.attr("type",obj.attr("type"));
  $(obj).find("obj-prototype").after(el);
  renderCustomItem(el);
  bindEvents();
  saveButtonEnable();
  return el
}


/*
Это все про клик ту ролл - пока можно убрать

var oldBindEvents=bindEvents;
bindEvents=function(){
  oldBindEvents();

  globalChar.find("gc-dots").unbind("click").bind("click",function () {
    if(lockedMode){
      clickRoll($(this));
      event.stopPropagation();
    }
  });
};


var globalClickRollHolder="";
function clickRoll(obj){
  if (globalClickRollHolder=="") {
    globalClickRollHolder=obj;
    $("body").addClass("cursor-dices-pale");
  }
  else {
    $("body").removeClass("cursor-dices-pale");
    toolRollVtm(globalClickRollHolder.prev().int()+obj.prev().int(),globalClickRollHolder.parent().find(">name").text()+' + '+obj.parent().find(">name").text());
    globalClickRollHolder="";
  }
}
*/
