$(function () {
  $("char>board-buttons").before(`
<generator-popup>
<button class="secondary round" style="position: sticky; top: 0;float: right;" onclick="$('generator-popup').hide();"><i class="fa fa-close"></i></button>
<inputs>
  <select name="from-xml"></select>
  <input name="count" type="number" value="10" min="1" max="25" step="1" title="Сколько нагенерировать">  
  <custom-selects></custom-selects>
  <button class="secondary generator-spin" onclick='generatePerson();' title="Сгенерировать еще"><i class="i icon-random"></i></button>
  <button class="secondary to-board" onclick='addGenerationToBoard();' title="Добавить эту генерацию на лист персонажа"><i class="fa fa-caret-left"></i></button>  
</inputs>

  <results></results>
  <center><button onclick='generatePerson();' class="generator generator-spin"><i class="i icon-random"></i> еще</button></center>
</generator-popup>`);

  $("body").append(`
  <generator-panel class="use-zoom">
    <expander onClick="$(this).parent().toggleClass('show-panel'); $(generatorObj).focus();"></expander>
    <edit title="Изменить название" onClick="generatorItemChange(generatorObj);"></edit>
    <wide title="Шире-уже" onClick="generatorToggleWide(generatorObj); $(generatorObj).focus()"></wide>
    <add title="Добавить новое поле" onClick="generatorItemAdd(generatorObj);"></add>
    <delete title="Удалить" onClick="generatorItemDelete(generatorObj);"></delete>
    <up title="Свдинуть вверх" onClick="generatorSwap(generatorObj,true); $(generatorObj).focus()"></up>
    <down title="Сдвинуть вниз" onClick="generatorSwap(generatorObj,false); $(generatorObj).focus()"></down>
    <help title="Помощ" onClick="viewHint(generatorObj,true);"></help>
  </generator-panel>`);

  $("char").on('scroll',function() {hideGeneratorPanel();});
});


// Генерации описаний для NPC

var globalGeneration={};
globalGeneration['6aa19f29c7aec85d9c6e27a5a41d1777']='Mentor > Исторические';
globalGeneration['df6715ce5ac55ccb5891b4854f0188ad']='Mentor > Наше время';
globalGeneration['0ace57037c1a1d9ce3e5b6ab442ea542']='Mentor > Дикий запад';
globalGeneration['6aa19f29c7aec85d9c6e27a5a41d1777']='Mentor > Исторические';
globalGeneration['1a1ba77804bb4cae4aeb5f8ea8c28a99']='Mentor > Фэнтази';
globalGeneration['8db13013d23daa1830b2ac1eac9f81ea']='Mentor > Космос';
//$.getJSON( "lib/Generation/generation.json?rnd="+mentorVersion, function( data ) {globalGeneration=data;});

function prepareGeneration(thenDoGeneration){
  if ($("generator-popup").attr("ready")) return;
  var myGeneratorsHtml="";
  $("auth .my-generator").each(function(){
    var path="";
    $(this).parents(".my-campaign").each(function(){
      if ($(this).find(">.my-campaign-caption .my-campaign-id").text() != "") {
        path = $(this).find(">.my-campaign-caption .my-campaign-name").text() + " > " + path;
      }
    });
    myGeneratorsHtml+=("<option value='"+$(this).attr('char-link')+"'>"+path+$(this).find('.my-char-name-text').text()+"</option>");
  });
  $.each(globalGeneration,(function(k,v){
    myGeneratorsHtml+=("<option value='"+k+"'>"+v+"</option>");
  }));

  $("generator-popup *[name=from-xml]").html(myGeneratorsHtml).on("change",function (){
    $("generator-popup custom-selects").html("");
    if (thenDoGeneration) generationGetCustomSettings($(this).val(),true);
    $.cookie("from-xml",$(this).val(),{ expires: 10 * 365 });
  }).find("option[value='"+$.cookie("from-xml")+"']").attr("selected",true);
  $("generator-popup *[name=from-xml]").change();

  $("generator-popup").attr("ready",true);
}

function generationGetCustomSettings(char,reload,cb){
  $("generator-popup custom-selects").load("generate-person.php?get_settings_for="+char,function(){
    $("generator-popup custom-selects select").each(function(){

      var savedVal=$.cookie(char+$(this).attr('name'));
      var obj=$(this);

      $.each(savedVal.split(","), function(i,e){
        obj.find("option[value='"+e+"']").attr("selected",true);
      });
    });

    $("generator-popup custom-selects select").on("change",function(){
      // $(this).lightStatus("has-value",$(this).find('option:selected').val()>=0);
      $.cookie(char+$(this).attr('name'),$(this).val(),{ expires: 10 * 365 });
      generatePerson();
    });

    echo(111);
    if (cb) cb();
    if (reload) generatePerson();
  });
}

function showGenerator(forceShow,doNotGenerate){
  prepareGeneration(!doNotGenerate);
  if (forceShow) $("generator-popup").show();
  else $("generator-popup").toggle();
}

function generatePerson(addToRequest,getJsonOnly){
  var params=addToRequest||{};
  $("generator-popup custom-selects select").each(function(){
    params[$(this).attr('name')]=$(this).val();
  });
  params['from-xml']=$("generator-popup *[name=from-xml]").val();
  params['count']=$("generator-popup *[name=count]").val();
  if (getJsonOnly) return JSON.stringify(params);
  generateWithParams(params);
}
function generateWithParams(params,restoreUiElements){
  if (restoreUiElements){
    $("generator-popup button").prop("disabled","disabled");
    $("generator-popup *[name=count]").val(params['count']);
    $("generator-popup *[name=from-xml]").val(params['from-xml']);
    generationGetCustomSettings(params['from-xml'],false,function(){
      // адский лапшекод аж стыдно до сраму 8(((
      $("generator-popup custom-selects select option").prop("selected",false);
      for (i=0;i<30;i++){
        if (Array.isArray(params['custom['+i+']'])) {
          params['custom['+i+']'].forEach(function(v){
            $($("generator-popup custom-selects select")[i]).find("option[value='"+v+"']").prop("selected","selected");
          });
        };
      }

    });
  }
  echo(1);
  $("generator-popup results").load("generate-person.php",params,
    function () {
      $("generator-popup button").removeProp("disabled");

      $("generator-popup results text-block").append("<button class='nocopy secondary to-board'><i class='fa fa-caret-left'></i> на лист</button>")
      $("generator-popup results button").on("click",function () {
        var copy=$(this).parent().clone();
        copy.find(".nocopy").remove();
        copy.attr("style","top: "+getBoardOffset('top')+"px; left: "+getBoardOffset('left')+"px; width: 300px; height: 300px; position: absolute;");
        copy.appendTo("gm-board");
        $("generator-popup").hide();
        renderBoard();
        saveButtonEnable();
      });
    }
  );
}

function generatorTestRun(addToRequest){
  prepareGeneration(false);
  $("generator-popup *[name='from-xml']").html("<option selected value='"+currentChar+"'></option>").hide();

  $("generator-popup custom-selects").html("");
  generationGetCustomSettings(currentChar,false);

  $("generator-popup").show();

  var tags=globalChar.find("br,generator>lists>item>*,generator>format>*,generator>vars>*");
  if (tags.length){tags.remove(); saveButtonEnable();}

  if (viewerMode) generatePerson(addToRequest);
  else saveCurrentChar(false,function (){generatePerson(addToRequest)});
}

function renderGenerator() {
    var generator=globalChar.find("generator");
    clearObj(generator);
    generator.find(">lists>*,>format,>vars")
      .addClass("editable")
      .unbind("click")
      .bind("click", function () {
      viewHint($(this));
      return false;
    });

    generator.prepend("<button class='btn nosave generator generator-spin' onclick='generatorTestRun()'><i class='i icon-random'></i> Генерировать (Alt-G)</button>");
    if (viewerMode) generatorTestRun();

    globalChar.find("generator>lists>*,generator>vars,generator>vars,generator>format").unbind("focus").bind("focus",showGeneratorPanel).unbind("blur").bind("blur",hideGeneratorPanelShedule);

    $("<button class='nosave secondary structure-btn'><i class='fa fa-caret-down'></i> Показать структуру</button>").on('click',function(){globalChar.find("generator").toggleClass('show-all')}).insertAfter("generator>profile");

    bindEvents();
}

$("body").bind('keydown',function () {
  if (generatorMode){
    if(event.altKey&&event.keyCode==71) {
      var add={};
      if (event.srcElement.localName=="item") {
        var sel=window.getSelection().toString();
        if (sel.length){
          add['subst-item']=$(event.srcElement).attr("name");
          add['subst-text']=sel;
        }
      }
      if (event.srcElement.localName=="format"||event.srcElement.localName=="vars") {
        var sel=window.getSelection().toString();
        if (sel.length){
          add['subst-item']="#"+event.srcElement.localName;
          add['subst-text']=sel;
        }
      }
      generatorTestRun(add);
    }
  }

});

var generatorObj = {};
var generatorPanelTimeout;
function showGeneratorPanel() {
  clearTimeout(generatorPanelTimeout);
  generatorObj = $(this);

  $("generator-panel").lightStatus("help-only",generatorObj[0].tagName!=="ITEM");

  $("generator-panel").css("top", $(this).offset().top);
  $("generator-panel").css("left", $(this).offset().left + $(this).width());
  $("generator-panel").show();
}
function hideGeneratorPanel(){
  $("generator-panel").hide();
}
function hideGeneratorPanelShedule() {
  clearTimeout(generatorPanelTimeout);
  if ($("generator-panel").is(":visible")) {
    generatorPanelTimeout = setTimeout(hideGeneratorPanel, 200);
  }
}
function generatorSwap(obj,isLeft){
  if (isLeft) $(obj).prev().before($(obj));
  else $(obj).next().after($(obj));
  saveButtonEnable();
}
function generatorToggleWide(obj){

  if ($(obj).attr('double')!==undefined) {$(obj).attr('wide','').removeAttr('double');}
  else if($(obj).attr('wide')!==undefined) {$(obj).attr('fill','').removeAttr('wide');}
  else if($(obj).attr('fill')!==undefined) {$(obj).removeAttr('fill');}
  else {$(obj).attr('double','')}

  //double - wide - fill
  //$(obj).toggleAttr('wide');
  saveButtonEnable();
}

function generatorItemNameClear(name){
  var ret=name.replace(/[^A-Za-z0-9_-]/g,'').toLowerCase();
  if (ret=="") ret="no-name";
  return ret
}

function generatorItemAdd(obj) {
  modalPopup("<h2>Добавить поле</h2><line><input type='text' placeholder='название' autofocus style='margin:0; width:100%;'></line>" +
    "<div class='note'>Только строчные английские буквы, цифры, дефис и подчеркаивания</div>",
    "Добавить", "Отмена", function () {
    var el = $("<item class='editable' name='"+generatorItemNameClear($("modalpopup input").val())+"'></item>");
    $(obj).after(el);
    saveButtonEnable();
    renderGenerator();
    el[0].focus();
  },null,function(){$("modalpopup input").focus()});
}

function generatorItemChange(obj) {
  modalPopup("<h2>Измеить поле</h2>"+generatorItemStat(obj)+"<line><input type='text' placeholder='название' autofocus style='margin:0; width:100%;' value='"+$(obj).attr("name")+"'></line>"+
    "<div class='note'>Только строчные английские буквы, цифры, дефис и подчеркаивания</div>",
    "Изменить", "Отмена", function () {
    $(obj).attr("name",generatorItemNameClear($("modalpopup input").val()));
    saveButtonEnable();
    $(obj)[0].focus();
    },null,function(){$("modalpopup input").focus()});
}
function generatorItemDelete(obj){
  if ($(globalChar).find("lists item").length==1) {modalPopup("Последний список удалять нельзя :-P","Понятно"); return;}
  modalPopup("Точно удалить","Удалить","Не удалять",function () {$(obj).remove(); saveButtonEnable();});
}

function generatorItemStat(obj){
  var lines=$(obj).text().split("\n");
  cleared=lines.filter(str => !(str.replace(/ /g,'') == ""||str[0]=="#"||(str[0]=="/"&&str[1]=="/")));
  var doubles=cleared.length-[...new Set(cleared)].length;
  return "Рабочих строк "+cleared.length+", дублей "+doubles;
}

function addGenerationToBoard(){
  var action=generatePerson({},true);
  var name=$("generator-popup *[name=from-xml] option:selected").text().replace(/^(.*)> /gm,'');
  addBoardButton('generator',name,action);
}

